
//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//
    
extern int                DeMarkerPeriod  = 14;
extern double             value1          = 0.55;
extern double             value2          = 0.45;
input bool                alertsOn        = false;             // Alerts true/false?
input bool                alertsOnCurrent = true;              // Alerts open bar true/false?
input bool                alertsMessage   = true;              // Alerts message true/false?
input bool                alertsSound     = false;             // Alerts sound true/false?
input bool                alertsNotify    = false;             // Alerts push notification true/false?
input bool                alertsEmail     = false;             // Alerts email true/false?
input string              soundFile       = "alert2.wav";      // Sound file

//
//
//
//
//

double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle (0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle (1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtBuffer3); SetIndexStyle (2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,trend);
   IndicatorShortName("Demarker Custom"); 
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {  
      trend[i] = 0;
      if (iDeMarker(NULL,0,DeMarkerPeriod,i) > value1)                                                trend[i] = 1; 
      if (iDeMarker(NULL,0,DeMarkerPeriod,i) < value2)                                                trend[i] =-1;
      if (iDeMarker(NULL,0,DeMarkerPeriod,i) < value1 && iDeMarker(NULL,0,DeMarkerPeriod,i) > value2) trend[i] = 0;
      
      //
      //
      //
      //
      //
      
      ExtBuffer1[i] = EMPTY_VALUE;
      ExtBuffer2[i] = EMPTY_VALUE;
      ExtBuffer3[i] = EMPTY_VALUE;
      if (trend[i] == 1) ExtBuffer1[i] = 1;
      if (trend[i] ==-1) ExtBuffer2[i] = 1;
      if (trend[i] == 0) ExtBuffer3[i] = 1;   
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
        if (trend[whichBar] == 1) doAlert("up");
        if (trend[whichBar] ==-1) doAlert("down");  
      }     
   }
return(0);
}

//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" demarker custom "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" demarker custom ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

  

